import  json

# paper size A4
width = 210
height = 297
x_ofst = 10
y_ofst = 10

dx_intra = 2.5
dx_inter = 6
dy_intra = 2.5
dy_inter = 10
dy_l_f   = dy_inter-(2*dy_intra)

x_char_max = (width-(2*x_ofst))/6
y_char_max = (height-(2*y_ofst))/10


text_file = open("text.txt","r")
text= text_file.read()
#print text

with open('braille_data.json') as f:
    braille = json.load(f)

txt_len = len(text)
y_char = txt_len/x_char_max
x_char = x_char_max
if ((txt_len%x_char_max)!=0):
    y_char+=1
if txt_len<x_char_max:
    x_char=txt_len

"""
txt_array = [[0 for x in range(x_char_max)] for y in range(y_char)]
for j in range(y_char):
    #if j== (y_char-1):
        #x_char= txt_len-(x_char_max*j)
        #print x_char
    for i in range(x_char):
        n = (x_char_max*j)+i+j
        try:
            txt_array[j][i] = text[n]
        except IndexError:
            txt_array[j][i] = ""
print txt_array

"""

txt_array = [[0 for x in range(x_char_max)]]
#y_code_array=[]

def make_txt_array():
    i = 0
    txt_row = ["" for x in range(x_char_max)]
    global txt_array

    for n in range(txt_len):
        if(text[n]!= "\n" and i< x_char_max ):
            txt_row[i]=text[n].lower()
            i+=1
        elif (text[n]=="\n"):
            i=0
            txt_array.append(txt_row)
            txt_row = ["" for x in range(x_char_max)]
            txt_array[0][0]+=1
        elif (i>= x_char_max):

            txt_array.append(txt_row)
            txt_row = ["" for x in range(x_char_max)]
            i=0
            txt_row[i]=text[n].lower()
            i+=1
            txt_array[0][0]+=1
    txt_array[0][0]+=1


def y_code():
    global x_char_max
    global txt_array
    global y_code_array
    y_code_array = []

    for p in range (1,txt_array[0][0]):
        for q in range(3):
            y_pos = ((p-1)*dy_inter)+y_ofst+(q*dy_intra)
            y_code_array += ["Y"+str(y_pos)]
            for r in range(x_char_max):
                try:
                    print txt_array[p][r]
                    if braille[txt_array[p][r]][q][0] == 1:
                        pos = (r*dx_inter)+x_ofst
                        y_code_array+= ["EX"+str(pos)]
                    if braille[txt_array[p][r]][q][1] == 1:
                        pos = (r*dx_inter)+x_ofst+dx_intra
                        y_code_array+= ["EX"+str(pos)]
                except IndexError:
                    #pass
                    print "error"

def g_code():
    global x_char_max
    global txt_array
    global g_code_array
    g_code_array = []
    g_code_array+=["SA"]
    g_code_array+=["PAUSE"]
    g_code_array+=["MS,40,25"]
    g_code_array+=["JZ,20"]
    g_code_array+=["J2,0,0"]



    for p in range (1,txt_array[0][0]):
        for q in range(3):
            y_pos = ((p-1)*dy_inter)+y_ofst+(q*dy_intra)
            #y_code_array += ["Y"+str(y_pos)]
            for r in range(x_char_max):
                try:
                    if braille[txt_array[p][r]][q][0] == 1:
                        pos = (r*dx_inter)+x_ofst
                        g_code_array+= ["J2,-"+str(pos)+",-"+str(y_pos)]
                        g_code_array+= ["JZ,-1"]
                        g_code_array+= ["JZ,10"]

                    if braille[txt_array[p][r]][q][1] == 1:
                        pos = (r*dx_inter)+x_ofst+dx_intra
                        g_code_array+= ["J2,-"+str(pos)+",-"+str(y_pos)]
                        g_code_array+= ["JZ,-1"]
                        g_code_array+= ["JZ,10"]

                except IndexError:
                    #pass
                    print "error"
    g_code_array+= ["JZ,20"]
    g_code_array+= ["J2,0,0"]

def write_code():
    global g_code_file
    global g_code_array
    g_code_file=open("g_code.sbp",'w')
    for lines in g_code_array:
    #    g_code_file.write("%s\n",g_code_array[lines])
        print>>g_code_file, lines
    print "Done"


make_txt_array()
print txt_array
g_code()
write_code()
#print y_code_array

